import { Log } from "@dao-xyz/peerbit-log";
import { Entry } from "@dao-xyz/peerbit-log";
export const join = async (entry, into, options) => {
    // Notify the Store that we made progress
    const shouldFetch = (h) => {
        if (!h) {
            throw new Error("Unexpected");
        }
        return !into.has(h);
    };
    let log;
    if (typeof entry === "string" ||
        (Array.isArray(entry) &&
            (entry.length === 0 || typeof entry[0] === "string"))) {
        log = await Log.fromEntryHash(into.storage, into.identity, entry, {
            // TODO, load all store options?
            encryption: into.encryption,
            encoding: into.encoding,
            sortFn: into.sortFn,
            length: -1,
            exclude: [],
            shouldFetch,
            concurrency: options?.concurrency,
            onFetched: options?.onFetched,
            replicate: true,
        });
    }
    else {
        let entries;
        if (Array.isArray(entry)) {
            if (entry[0] instanceof Entry) {
                entries = entry;
            }
            else {
                entries = [];
                for (const e of entry) {
                    entries.push(e.entry);
                    e.references.forEach((ref) => {
                        entries.push(ref);
                    });
                }
            }
        }
        else {
            entries = [entry];
        }
        log = await Log.fromEntry(into.storage, into.identity, entries, {
            // TODO, load all store options?
            encryption: into.encryption,
            encoding: into.encoding,
            sortFn: into.sortFn,
            length: -1,
            shouldFetch,
            concurrency: options?.concurrency,
            onFetched: options?.onFetched,
            replicate: true,
        });
    }
    return into.join(log);
};
//# sourceMappingURL=replicator.js.map